clear all;
noRep=1;
ONP=1/10; %%%% 1/ average length of the Lossy period
OFFP =1/5; %%%1/average length of the Lossless period
lambda = 0.1;

lambdaArray=[0.1:0.1:1];
k1Array=[1:1:10];
k2Array=[1:1:10];
for lambdaID =1:1:1
    lambda=lambdaArray(lambdaID);
    %theta(2)=thetaidx;
    for k1ID=3:2:3
        ko(1)=k1Array(k1ID);
        for k2ID=6:1:6
            ko(2)=k2Array(k2ID);
            
            for rep=1:noRep
                
                thetao=[1/(ko(1)*ONP)  1/(ko(2)*OFFP)];
                n_samples=min(10000,floor(5000*(1/OFFP +1/ONP)/lambda));
                
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %%%%%% Simulate the input
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                disp(['Simulating the Alternating Renewal Gamma Process with parameters:',...
                    ' lambda=',num2str(lambda),' ,k(1)=',num2str(ko(1)),' ,k(2)=',...
                    num2str(ko(2)),' ,theta(1)=',num2str(thetao(1)),' ,theta(2)=',num2str(thetao(2))]);
                
                %%%%%% Gamma
                trce=-1*ones(n_samples,1);
                A_seq = cumsum(- log(rand(n_samples,1))/lambda); %% arrival time of samples;
                ON_seq= mygamrnd(ko(1),thetao(1),2*n_samples,0);
                OFF_seq= mygamrnd(ko(2),thetao(2),2*n_samples,0);
                
                R_seq=[0];
                
                idx=1;
                for i=1:2*n_samples
                    R_seq(idx+1) =R_seq(idx) + ON_seq(i);
                    R_seq(idx+2)= R_seq(idx+1) + OFF_seq(i);
                    idx=idx+2;
                end
                
                current_j=1;
                for i=1:n_samples
                    for j=current_j:length(R_seq)-1
                        if ((A_seq(i) > R_seq(j))&&(A_seq(i)<=R_seq(j+1)))
                            current_j=j;
                            break;
                        end
                    end
                    
                    if (mod(current_j,2) == 1)
                        trce(i)=0; %loss
                    else
                        trce(i)=1; %good
                    end
                    
                end
                
                
                ON=[];
                OFF=[];
                current_i=1;
                for j=1:length(R_seq)-1
                    if R_seq(j) <= A_seq(length(A_seq))
                        cOn=0;
                        cOff=0;
                        if (mod(j,2) == 1)
                            for i=current_i:n_samples
                                if ((A_seq(i) > R_seq(j))&&(A_seq(i)<=R_seq(j+1)))
                                    cOn=cOn+1;
                                    %%current_i=i;
                                end
                            end
                            ON=[ON cOn];
                        else
                            for i=current_i:n_samples
                                if ((A_seq(i) > R_seq(j))&&(A_seq(i)<=R_seq(j+1)))
                                    cOff=cOff+1;
                                    %%%current_i=i;
                                end
                            end
                            OFF=[OFF cOff];
                        end
                    else
                        break
                    end
                end
                
                
                
                disp(['Start counting ...']);
                
                L=[];
                NL=[];
                SL=[];
                Ydash=[];
                Zdash=[];
                
                i=1;
                
                LR =0;
                NLR=0;
                while (i <= length(trce))
                    if ((trce(i)==1)&(NLR>0))
                        NLR=NLR+1;
                    elseif  ((trce(i)==1)&(NLR==0))
                        if (LR >0)
                            L=[L LR];
                            Ydash=[Ydash A_seq(i)-startL];
                        end
                        LR=0;
                        NLR=NLR+1;
                        startNL=A_seq(i);
                    elseif ((trce(i)==0)&(LR>0))
                        LR =LR+1;
                    elseif ((trce(i)==0)&(LR==0))
                        if (NLR>0)
                            NL=[NL NLR];
                            Zdash=[Zdash A_seq(i)-startNL];
                        end
                        NLR=0;
                        LR=LR+1;
                        startL=A_seq(i);
                    end
                    i=i+1;
                end
                
                
                if (length(L)<length(NL))
                    NL=NL(1:length(L));
                elseif (length(L)>length(NL))
                    L=L(1:length(NL));
                end
                
                LDist(rep,1:10) =L(1:10)
                NLDist(rep,1:10)=NL(1:10);
                NoRenewal(rep) = length(L);
                
                disp(['Collecting Probs ...']);
                
                po =1/(1-1/((lambda*thetao(1)+1)^(ko(1)) * (lambda*thetao(2)+1)^(ko(2))))
                condProb = (1-1/((lambda*thetao(1)+1)^(ko(1))))*po*(1-1/((lambda*thetao(2)+1)^(ko(2))))
                validProbOFF=(1-1/(lambda*thetao(1)+1)^(ko(1)))*po^2*(1-1/(lambda*thetao(1)+1)^(ko(1)));
                validProbON=(1-1/(lambda*thetao(2)+1)^(ko(2)))*po^2*(1-1/(lambda*thetao(2)+1)^(ko(2)));
                
                validProbOFFNEW=(1-1/(lambda*thetao(1)+1)^(ko(1)))*po^2*(1-1/(lambda*thetao(1)+1)^(ko(1)));
                validProbONNEW=(1-1/(lambda*thetao(2)+1)^(ko(2)))*po^2*(1-1/(lambda*thetao(2)+1)^(ko(2)));
                
                a = 1/((lambda*thetao(1)+1)^(ko(1)));
                b=1/((lambda*thetao(2)+1)^(ko(2)));
                
                n=1;
                probOFFOLD(1)=((lambda*thetao(2))^n*nchoosek(n+ko(2)-1,n)/((lambda*thetao(2)+1)^(n+ko(2))))*validProbOFF/condProb;
                probONOLD(1)=((lambda*thetao(1))^n*nchoosek(n+ko(1)-1,n)/((lambda*thetao(1)+1)^(n+ko(1))))*validProbON/condProb;
                
                
                n=2;
                probOFFOLD(2)=((lambda*thetao(2))^n*nchoosek(n+ko(2)-1,n)/((lambda*thetao(2)+1)^(n+ko(2))))*validProbOFF/condProb;
                n=1; probOFFOLD(2)=probOFFOLD(2) + ((lambda*thetao(2))^n*nchoosek(n+ko(2)-1,n)/((lambda*thetao(2)+1)^(n+ko(2))))^2*1/(lambda*thetao(1)+1)^(ko(1))*validProbOFF/condProb;
                n=2;probONOLD(2)= ((lambda*thetao(1))^n*nchoosek(n+ko(1)-1,n)/((lambda*thetao(1)+1)^(n+ko(1))))*validProbON/condProb;
                n=1;probONOLD(2)=probONOLD(2)+((lambda*thetao(1))^n*nchoosek(n+ko(1)-1,n)/((lambda*thetao(1)+1)^(n+ko(1))))^2*1/(lambda*thetao(2)+1)^(ko(2))*validProbON/condProb;
                
                probOFF(3)=0;
                probON(3)=0;
                for n=1:2
                    probOFF(3)=probOFF(3) +((lambda*thetao(2))^n*nchoosek(n+ko(2)-1,n)/((lambda*thetao(2)+1)^(n+ko(2))))*1/(lambda*thetao(1)+1)^(ko(1))*probOFF(3-n);
                    probON(3)=probON(3) +((lambda*thetao(1))^n*nchoosek(n+ko(1)-1,n)/((lambda*thetao(1)+1)^(n+ko(1))))*1/(lambda*thetao(2)+1)^(ko(2))*probON(3-n);
                end
                n=3; probOFF(3)=probOFF(3)+((lambda*thetao(2))^n*nchoosek(n+ko(2)-1,n)/((lambda*thetao(2)+1)^(n+ko(2))))*validProbOFF/condProb;
                probON(3)=probON(3)+((lambda*thetao(1))^n*nchoosek(n+ko(1)-1,n)/((lambda*thetao(1)+1)^(n+ko(1))))*validProbON/condProb;
                
                
                for idx=1:20
                    probON(idx)=0;
                    probOFF(idx)=0;
                    probONNEW(idx)=0;
                    probOFFNEW(idx)=0;
                    for n=1:idx-1
                        probON(idx)=probON(idx)+((lambda*thetao(1))^n*nchoosek(n+ko(1)-1,n)/((lambda*thetao(1)+1)^(n+ko(1))))*1/(lambda*thetao(2)+1)^(ko(2))*po*probON(idx-n);
                        probOFF(idx)=probOFF(idx)+((lambda*thetao(2))^n*nchoosek(n+ko(2)-1,n)/((lambda*thetao(2)+1)^(n+ko(2))))*1/(lambda*thetao(1)+1)^(ko(1))*po*probOFF(idx-n);
                        probONNEW(idx)=probONNEW(idx)+((lambda*thetao(1))^n*nchoosek(n+ko(1)-1,n)/((lambda*thetao(1)+1)^(n+ko(1))))*1/(lambda*thetao(2)+1)^(ko(2))*probONNEW(idx-n);
                        probOFFNEW(idx)=probOFFNEW(idx)+((lambda*thetao(2))^n*nchoosek(n+ko(2)-1,n)/((lambda*thetao(2)+1)^(n+ko(2))))*1/(lambda*thetao(1)+1)^(ko(1))*probOFFNEW(idx-n);
                    end
                    n=idx;probON(idx)= probON(idx) + ((lambda*thetao(1))^n*nchoosek(n+ko(1)-1,n)/((lambda*thetao(1)+1)^(n+ko(1))))*validProbON/condProb;
                    probOFF(idx)=probOFF(idx)+((lambda*thetao(2))^n*nchoosek(n+ko(2)-1,n)/((lambda*thetao(2)+1)^(n+ko(2))))*validProbOFF/condProb;
                    
                    probONNEW(idx)= probONNEW(idx) + ((lambda*thetao(1))^n*nchoosek(n+ko(1)-1,n)/((lambda*thetao(1)+1)^(n+ko(1))))*validProbONNEW/condProb;
                    probOFFNEW(idx)=probOFFNEW(idx)+((lambda*thetao(2))^n*nchoosek(n+ko(2)-1,n)/((lambda*thetao(2)+1)^(n+ko(2))))*validProbOFFNEW/condProb;
                    
                    impiricalON(rep,idx)=length(find(L==idx))/length(L);
                    impiricalOFF(rep,idx)=length(find(NL==idx))/length(NL);
                end
                
                EYdash(rep) = lambda*thetao(1)*ko(1)*(1-a*b)/((1-a)*(1-b)); 
                EZdash(rep) = lambda*thetao(2)*ko(2)*(1-a*b)/((1-b)*(1-a));
                %lambda*thetao(1)*ko(1)*(po*(1-1/(lambda*thetao(2)+1)^(ko(2))))^2/condProb/(1-po/(lambda*thetao(2)+1)^(ko(2))*(1-1/(lambda*thetao(1)+1)^(ko(1))))^2;
                %lambda*thetao(2)*ko(2)*(po*(1-1/(lambda*thetao(1)+1)^(ko(1))))^2/condProb/(1-po/(lambda*thetao(1)+1)^(ko(1))*(1-1/(lambda*thetao(2)+1)^(ko(2))))^2;
                
                
                
                EYdashsquare(rep) = 2*lambda*thetao(1)*ko(1)*(1-a*b)*(1-b+b*lambda*thetao(1)*ko(1))/((1-a)*(1-b)^2);
                EZdashsquare(rep) = 2*lambda*thetao(2)*ko(2)*(1-a*b)*(1-a+a*lambda*thetao(2)*ko(2))/((1-b)*(1-a)^2);
                
                
            end
        end
    end
end



