%%%%
% 1. Generate the simulated trace using exponential ON and OFF duration
% 2. Infer the renewal model using the HMM
% 3. Validate
% copyright: hung.nguyen@adelaide.edu.au
%%%%%%%%%

clear all

ONP=1/1; %%%% 1/ average length of the Lossy period
OFFP =1/10; %%%1/average length of the Lossless period
lambda = 1;
n_samples=10000;

%%%gamma dist
ko=[5 1];
thetao=[1/(ko(1)*ONP)  1/(ko(2)*OFFP)];

ksol =[];
thetasol=[];

for lambda =0.1:0.1:0.1
    
    lambda
    %theta(2)=thetaidx;
    
    for rep=1:1

        rep
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%%%% Simulate the input
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        samples=-1*ones(n_samples,1);

        %%%%%% Gamma
        A_seq = cumsum(- log(rand(n_samples,1))/lambda); %% arrival time of samples;
        ON_seq= mygamrnd(ko(1),thetao(1),2*n_samples,0);
        OFF_seq= mygamrnd(ko(2),thetao(2),2*n_samples,0);

        R_seq=[0];

        idx=1;
        for i=1:2*n_samples
            R_seq(idx+1) =R_seq(idx) + ON_seq(i);
            R_seq(idx+2)= R_seq(idx+1) + OFF_seq(i);
            idx=idx+2;
        end

        current_j=1;
        for i=1:n_samples
            for j=current_j:length(R_seq)-1
                if ((A_seq(i) > R_seq(j))&&(A_seq(i)<=R_seq(j+1)))
                    current_j=j;
                    break;
                end
            end

            if (mod(current_j,2) == 1)
                samples(i)=1;
            else
                samples(i)=0;
            end

        end

        trce=1-samples;
        trceTime=A_seq;
        
        %%%%%%%%%End data generation%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%% Starting the  inference 
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        inferTrce =[];
        validTrce =[];

        thinningS=2;
        tempk1=[1:1:ceil(length(trce)/thinningS)];
        tempk2=[(ceil(length(trce)/thinningS)+1):1:length(trce)];


        inferTrce= trce(tempk1);
        validTrce = trce(tempk2);
        trceTime=trceTime(tempk1);

        timeInt=1/(2*lambda);%%%(2*lambda);    %%%%% WHY WHY WHY WHY????????

        trce= inferTrce;
        
       
        [kold thetaold rhotd omegatd scaling]= HSMM(lambda,trceTime,timeInt,trce);
        
    end %rep
end %lambda

